//+------------------------------------------------------------------+
//|                                        Swore2-Move Capture high ATR.mq4 |
//|                                                      swore2 |
//+------------------------------------------------------------------+
//rule:
//1. ATR(1)>MinTradeATRʱƽƵһbar¸5㣬limit
//3. ֹ10㡣

#property copyright "swore2"
#property link      ""
//---- input parameters
extern double lotsize = 0.1;
extern int MagicNumber = 1111;

extern int BurstDistance=3; //7*DeltaPrice
extern int StopLoss=15; //15*DeltaPrice
extern int TargetPrfit=6; //6*DeltaPrice

extern int   FastSMA = 3;
extern int  expirationBars = 30;

int   MylossLevel =10; //10 point
//----
datetime order_time = 0;
double DeltaPrice=0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   MylossLevel = StopLoss;
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }


void ModifyFollowLossLevel()
{
   double curStopLoss=0,curTakeProfit=0,curExpiration=0;
   int type=0;
   double SlowSMA1,SlowSMA2;
   
   int totalorders = OrdersTotal();
   for(int i=0;i<totalorders;i++) 
   {
      OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
      if( OrderSymbol()!=Symbol())continue;
      
      curStopLoss = OrderStopLoss();
      curTakeProfit = OrderTakeProfit();
      curExpiration = OrderExpiration();
      Print("last order's profit=",OrderProfit());
      if(OrderProfit() <= 0 || OrderMagicNumber()!=MagicNumber)continue;   //ûӯ߿ûбҪֹ
      
      type = OrderType();
      if( type == OP_BUY || type == OP_BUYLIMIT  || type == OP_BUYSTOP )
      {// long position, ¸
         if((High[0]-MylossLevel*(DeltaPrice)) > curStopLoss)
         {
            OrderModify(OrderTicket(),0,High[0]-MylossLevel*(DeltaPrice),curTakeProfit,curExpiration,CLR_NONE);
            Print("ticket=",OrderTicket(),"long position, new losslevel=",High[0]-MylossLevel*(DeltaPrice));
         }
      }
      else if ( type == OP_SELL || type == OP_SELLLIMIT  || type == OP_SELLSTOP )
      {// short positionµ
         if((Low[0]+MylossLevel*(DeltaPrice)) < curStopLoss)
         {
            OrderModify(OrderTicket(),0,Low[0]+MylossLevel*(DeltaPrice),curTakeProfit,curExpiration,CLR_NONE);
            Print("ticket=",OrderTicket(),"short position, new losslevel=",Low[0]+MylossLevel*(DeltaPrice));
         }
     }
   }
}

//+------------------------------------------------------------------------+
//| cancells all pending orders                                      |
//+------------------------------------------------------------------------+

void CloseAllPendingOrders( )
  {
     int totalorders = OrdersTotal();
     for(int i=totalorders-1;i>=0;i--)                                // scan all orders and positions...
      {
        OrderSelect(i, SELECT_BY_POS);
// modified as per cori. Using OrderMagicNumber to identify the trades of the grid // hdb added or gridname for compatibility
        if ( OrderSymbol()==Symbol() )  // only look if mygrid and symbol...
         {  
          if ( OrderType() > 1 ) bool result = OrderDelete( OrderTicket() );
         }
      } 
   return;
  }
double LastAccountEquity = 0;
int LastBar=0;
double GetProfitOut = 0;
double LastLotSize = 0;
double LastRealOrderTicket = 0;
bool LastOrderIsStop = true;
bool NextOrderShouldBeStop = false;
int NNN=1;
int GetCurLotSize()
{
   int totalorders = OrdersHistoryTotal();
   NNN = AccountEquity()/2000 * 0.36;
   if(NNN<1)NNN=1;
   for(int i=totalorders-1;i>0;i--)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_HISTORY );
      if(OrderProfit()!=0)
      {
         if(LastRealOrderTicket != OrderTicket())
            LastRealOrderTicket = OrderTicket();   
         else
            return(lotsize);
         break; //ʾһʵ׵orderexpiration.
      }
   }
   
      if(OrderProfit() < 0)
         lotsize=0.1*NNN;
      else if(OrderProfit() == 0)
         lotsize=lotsize;
      else if(OrderProfit() > 0)
         lotsize=lotsize;//lotsize+=0.1*NNN;
   lotsize = MathRound(lotsize*10.0)/10.0;
   if(lotsize>1000)lotsize=1000;
   LastLotSize = lotsize;
   if(!(OrderProfit() < 0 && NextOrderShouldBeStop == LastOrderIsStop))
      NextOrderShouldBeStop = (!LastOrderIsStop);
   Comment("lotsize=",lotsize, ", totalhistoryOrder=",totalorders,
            ", lastOrderProfit=",OrderProfit(),
            ", curEquity=", AccountEquity());   
   return(lotsize);//PermitOderNumber);
}
//+------------------------------------------------------------------------+
//| cancells all pending orders                                      |
//+------------------------------------------------------------------------+

void UpdateExpirationOrder( )
  {
     int totalorders = OrdersTotal();
     //Comment("bars=",Bars);
     for(int i=totalorders-1;i>=0;i--)                                // scan all orders and positions...
      {
        OrderSelect(i, SELECT_BY_POS);
        if(OrderSymbol()!=Symbol()|| OrderMagicNumber()!=MagicNumber)continue;
// modified as per cori. Using OrderMagicNumber to identify the trades of the grid // hdb added or gridname for compatibility
        if ( OrderType() > 1 && Time[0]-OrderOpenTime() > 60*expirationBars*Period())
        {
            bool result = OrderDelete( OrderTicket() );
        }
      } 
   return;
  }
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int GetCurChartTotalOrders()
{
   int totalorders = OrdersTotal();
   int retVal=0;
     //Comment("bars=",Bars);
     for(int i=totalorders-1;i>=0;i--)                                // scan all orders and positions...
      {
        OrderSelect(i, SELECT_BY_POS);
        if(OrderSymbol()!=Symbol())continue;
// modified as per cori. Using OrderMagicNumber to identify the trades of the grid // hdb added or gridname for compatibility
        if(OrderMagicNumber()==MagicNumber)
            retVal=retVal+1;
      } 
   return(retVal);
}
int start()
  {
   int ticket;
   if(DeltaPrice==0)
   {
      DeltaPrice=2*Point;//Ask-Bid;
   }
/* 
*/
// Defining the variables to decide.
   double BuyLimitPrice=0,SellLimitPrice=0;
   double FastSMA1=0,FastSMA2=0,SlowSMA1,SlowSMA2;
   
   order_time = iTime(Symbol(), 0, 0);
   UpdateExpirationOrder();
   if(GetCurChartTotalOrders()>0)
   {//ͷ̫˲С
      //ModifyFollowLossLevel();
      return(0);
   }
   if(true)//FindContinuousHighATR())
   {
     // GetCurLotSize();
      datetime expirationTime;
      double HighPrice,LowPrice,lostpoint,profittarget;
      
      expirationTime  = Time[0]+60*expirationBars*Period();
      //expirationTime = iTime( Symbol(), 0, 1)+4*(iTime( Symbol(), 0, 1) - iTime( Symbol(), 0, 2)) ;

      FastSMA1 = iMA(NULL,0,FastSMA,0,MODE_SMA,PRICE_MEDIAN,1);
      FastSMA2 = iMA(NULL,0,FastSMA,0,MODE_SMA,PRICE_MEDIAN,2);
      
    //  if(HighPrice-LowPrice<1.5*Point*MylossLevel)return(0);
      HighPrice = iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH, FastSMA,1));
      LowPrice = iLow(NULL,0,iLowest(NULL,0,MODE_LOW, FastSMA,1));
      HighPrice = MathRound(10000*HighPrice)/10000.0;
      LowPrice = MathRound(10000*LowPrice)/10000.0;
      
      if(HighPrice-LowPrice < BurstDistance*(DeltaPrice))return(0);
      if(High[1]>High[2] && High[2]>High[3] && High[3]<High[4])// && High[4]<High[5])
      {   
   //      GetCurLotSize();
         ticket = OrderSend(Symbol(), OP_BUYLIMIT, lotsize, LowPrice, DeltaPrice, 
            LowPrice-StopLoss*(DeltaPrice),
            LowPrice+TargetPrfit*(DeltaPrice),
            "", MagicNumber, 0, MediumBlue);
         if(ticket<0)
            Print("time=",TimeToStr(Time[0]),", ticket=",ticket,", BuyLimitPrice=",LowPrice,
                  ", Ask=", Ask, 
                  ", Bid=",Bid,
                  ",  err=", GetLastError(),
                  ", stop=",LowPrice-StopLoss*(DeltaPrice),
                  ", profit=",LowPrice+TargetPrfit*(DeltaPrice),
                  ", lotsize=",lotsize,
                  ", maketinfo->stoplevel=",MarketInfo(Symbol(),MODE_STOPLEVEL));
      }
      else if(Low[1]<Low[2] && Low[2]<Low[3] && Low[3]>Low[4])// && Low[4]>Low[5])
      {
 //        GetCurLotSize();
         ticket = OrderSend(Symbol(), OP_SELLLIMIT, lotsize, HighPrice, DeltaPrice, 
            HighPrice+StopLoss*(DeltaPrice),
            HighPrice-TargetPrfit*(DeltaPrice),
            "", MagicNumber, 0, Crimson);
         if(ticket<0)
            Print("time=",TimeToStr(Time[0]),", ticket=",ticket,", SellLimitPrice=",HighPrice,
                  ", Ask=", Ask, 
                  ", Bid=",Bid,
                  ",  err=", GetLastError(),
                  ", stop=",HighPrice+StopLoss*(DeltaPrice),
                  ", profit=",HighPrice-TargetPrfit*(DeltaPrice),
                  ", lotsize=",lotsize,
                  ", maketinfo->stoplevel=",MarketInfo(Symbol(),MODE_STOPLEVEL));
      }
   }

   return(0);
  }
//+------------------------------------------------------------------+